<script>
import { GlFilteredSearch } from '@gitlab/ui'
import isEmpty from 'lodash/isEmpty'

import { getSearchQuery } from '@/assets/get-search-query'
import { EVENT, DASHBOARD, CONTEXT_TOKEN_HASH } from '@/assets/constants'
import { extractUniqueValues } from '@/assets/utils'

function getIntialValue(context) {
  const searchQuery = getSearchQuery()

  if (isEmpty(searchQuery)) {
    if (context === EVENT) return []

    if (context === DASHBOARD)
      return [
        {
          type: 'type',
          value: {
            data: 'metrics',
            operator: '=',
          },
          id: 'type-token-6',
        },
      ]

    return [
      {
        type: 'status',
        value: {
          data: 'active',
          operator: '=',
        },
        id: 'status-token-1',
      },
    ]
  }
  return searchQuery
}

export default {
  components: {
    GlFilteredSearch,
  },
  props: {
    submitSearch: {
      type: Function,
      required: true,
    },
    clearSearch: {
      type: Function,
      required: true,
    },
    fetchedData: {
      type: Array,
      required: true,
    },
    context: {
      type: String,
      required: true,
    },
  },
  data() {
    return {
      value: getIntialValue(this.context),
    }
  },
  computed: {
    tokens() {
      return this.getTokens()
    },
  },
  watch: {
    fetchedData: {
      immediate: true,
      handler(newData) {
        if (newData && newData.length > 0) {
          window.requestAnimationFrame(() => {
            this.submitSearch(this.value, this.context)
          })
        }
      },
    },
    $route: {
      immediate: true,
      handler(to, from) {
        this.updateSearchValueFromRoute()
      },
    },
  },

  methods: {
    getTokens() {
      const tokens = CONTEXT_TOKEN_HASH[this.context]

      if (!tokens) return []

      return tokens.map((t) => ({
        ...t,
        extractFunction: () => this.extractValues(t.type),
      }))
    },
    blurSearchInput() {
      const searchInputEl = this.$refs.filteredSearchInput.$el.querySelector(
        '.gl-filtered-search-token-segment-input',
      )
      if (searchInputEl) {
        searchInputEl.blur()
      }
    },
    handleSubmit(tokens) {
      this.submitSearch(tokens, this.context)
      this.blurSearchInput()
    },
    updateSearchValueFromRoute() {
      const searchQuery = getSearchQuery()
      this.value = isEmpty(searchQuery)
        ? getIntialValue(this.context)
        : searchQuery
      this.submitSearch(this.value, this.context)
    },
    extractValues(key) {
      return extractUniqueValues(this.fetchedData, key, this.context)
    },
  },
}
</script>

<template>
  <gl-filtered-search
    ref="filteredSearchInput"
    v-model="value"
    :available-tokens="tokens"
    terms-as-tokens
    @submit="handleSubmit"
    @clear="clearSearch"
  />
</template>
